from functools import cache

from common.file import input_lines

NP = { # pre-computed moves between every pair of buttons on numpad
    '00': [''], '0A': ['>'], '01': ['^<'], '02': ['^'], '03': ['>^', '^>'], '04': ['^^<', '^<^'], '05': ['^^'], '06': ['^^>', '^>^', '>^^'], '07': ['^^^<', '^^<^', '^<^^'], '08': ['^^^'], '09': ['^^^>', '^^>^', '^>^^', '>^^^'],
    'A0': ['<'], 'AA': [''], 'A1': ['^<<', '<^<'], 'A2': ['^<', '<^'], 'A3': ['^'], 'A4': ['^^<<', '^<^<', '^<<^', '<^^<', '<^<^'], 'A5': ['^^<', '^<^', '<^^'], 'A6': ['^^'], 'A7': ['^^^<<'], 'A8': ['^^^<', '^^<^', '^<^^', '<^^^'], 'A9': ['^^^'],
    '10': ['>v'], '1A': ['>>v', '>v>'], '11': [''], '12': ['>'], '13': ['>>'], '14': ['^'], '15': ['>^', '^>'], '16': ['>>^', '>^>', '^>>'], '17': ['^^'], '18': ['>^^', '^>^', '^^>'], '19': ['>>^^', '>^>^', '>^^>', '^>>^', '^>^>', '^^>>'],
    '20': ['v'], '2A': ['>v', 'v>'], '21': ['<'], '22': [''], '23': ['>'], '24': ['<^', '^<'], '25': ['^'], '26': ['>^', '^>'], '27': ['<^^', '^<^', '^^<'], '28': ['^^'], '29': ['>^^', '^>^', '^^>'],
    '30': ['<v', 'v<'], '3A': ['v'], '31': ['<<'], '32': ['<'], '33': [''], '34': ['<<^', '<^<', '^<<'], '35': ['<^', '^<'], '36': ['^'], '37': ['<<^^', '<^<^', '<^^<', '^<<^', '^<^<', '^^<<'], '38': ['<^^', '^<^', '^^<'], '39': ['^^'],
    '40': ['>vv', 'v>v'], '4A': ['>>vv', '>v>v', '>vv>', 'v>>v', 'v>v>'], '41': ['v'], '42': ['>v', 'v>'], '43': ['>>v', '>v>', 'v>>'], '44': [''], '45': ['>'], '46': ['>>'], '47': ['^'], '48': ['>^', '^>'], '49': ['>>^', '>^>', '^>>'],
    '50': ['vv'], '5A': ['>vv', 'v>v', 'vv>'], '51': ['<v', 'v<'], '52': ['v'], '53': ['>v', 'v>'], '54': ['<'], '55': [''], '56': ['>'], '57': ['<^', '^<'], '58': ['^'], '59': ['>^', '^>'],
    '60': ['<vv', 'v<v', 'vv<'], '6A': ['vv'], '61': ['<<v', '<v<', 'v<<'], '62': ['<v', 'v<'], '63': ['v'], '64': ['<<'], '65': ['<'], '66': [''], '67': ['<<^', '<^<', '^<<'], '68': ['<^', '^<'], '69': ['^'],
    '70': ['>vvv', 'v>vv', 'vv>v'], '7A': ['>>vvv', '>v>vv', '>vv>v', '>vvv>', 'v>>vv', 'v>v>v', 'v>vv>', 'vv>>v', 'vv>v>'], '71': ['vv'], '72': ['>vv', 'v>v', 'vv>'], '73': ['>>vv', '>v>v', '>vv>', 'v>>v', 'v>v>', 'vv>>'], '74': ['v'], '75': ['>v', 'v>'], '76': ['>>v', '>v>', 'v>>'], '77': [''], '78': ['>'], '79': ['>>'],
    '80': ['vvv'], '8A': ['>vvv', 'v>vv', 'vv>v', 'vvv>'], '81': ['<vv', 'v<v', 'vv<'], '82': ['vv'], '83': ['>vv', 'v>v', 'vv>'], '84': ['<v', 'v<'], '85': ['v'], '86': ['>v', 'v>'], '87': ['<'], '88': [''], '89': ['>'],
    '90': ['<vvv', 'v<vv', 'vv<v', 'vvv<'], '9A': ['vvv'], '91': ['<<vv', '<v<v', '<vv<', 'v<<v', 'v<v<', 'vv<<'], '92': ['<vv', 'v<v', 'vv<'], '93': ['vv'], '94': ['<<v', '<v<', 'v<<'], '95': ['<v', 'v<'], '96': ['v'], '97': ['<<'], '98': ['<'], '99': [''],
}
DP = { # pre-computed moves between pairs of buttons on directional pad
    '<<': '', '<v': '>', '<^': '>^', '<>': '>>', '<A': '>>^',
    '^v': 'v', '^^': '', '^A': '>', '^<': 'v<', '^>': 'v>',
    'v<': '<', 'v^': '^', 'vv': '', 'v>': '>', 'vA': '^>',
    '>v': '<', '>A': '^', '><': '<<', '>>': '', '>^': '<^',
    'A^': '<', 'A>': 'v', 'A<': 'v<<', 'Av': '<v', 'AA': '',
}

@cache
def solve_dp(code: str, ttl: int) -> int:
    moves, pos = 0, 'A'
    for c in code:
        move = len(DP[pos + c])
        if ttl > 0:
            move = solve_dp(DP[pos + c] + 'A', ttl - 1)
        moves += move + (1 if ttl == 0 else 0)
        pos = c

    return moves

def solve_np(code: str, ttl: int = 2) -> int:
    moves, pos = 0, 'A'
    for c in code:
        min_length = None
        for move in NP[pos + c]:
            dp_move = solve_dp(move + 'A', ttl - 1)
            if min_length is None or min_length > dp_move:
                min_length = dp_move
        moves += min_length
        pos = c

    return moves

print(sum([int(code[:-1]) * solve_np(code, 2) for code in input_lines()]))
print(sum([int(code[:-1]) * solve_np(code, 25) for code in input_lines()]))